/*
 * Counter Demo for DIL/NetPC DNP/5280-3V
 * Author  : MHA@SSV <info@dilnetpc.com> <m.hasewinkel@web.de>
 * Date    : 26.08.2003
 * Version : 1.00
 * License : GPL
 */

#include <unistd.h>
#include <stdio.h>

#include "ssvhwa.h"

#define MCFBAR  0x40000000

#define PORTQA   (MCFBAR + 0x00190006)	/* 8 bit */
#define PORTQB   (MCFBAR + 0x00190007)	/* 8 bit */
#define DDRQA    (MCFBAR + 0x00190008)	/* 8 bit */
#define DDRQB    (MCFBAR + 0x00190009)	/* 8 bit */

void write_portA(unsigned char data)
{
    // write data Port A[0-3]
    ssvhwa_write8(PORTQA, ((data & 0x0c) << 1) | (data & 0x03));
    // write data Port A[4-7]
    ssvhwa_write8(PORTQB, (data >> 4));
}

int main(void)
{
    int iCnt;

    /* get user identity */
    if (geteuid() != 0) {
	fprintf (stderr,"No root access rights !\n");
	exit(1);
    }

    if (ssvhwa_open() < 0) {		// open ssvhwa driver
	perror("ssvhwa open");
	exit(-1);
    }

    ssvhwa_write8(DDRQA, 0x1b);		// Port A[0-3] output
    ssvhwa_write8(DDRQB, 0x0f);		// Port A[4-7] output

    printf ("  Start Binary Counter...\n");
    printf ("  Current Counter Value=   0");

    // run counter until user break by CTRL-C...
    for(;;) {

	// write 8-bit binary counter value to Port A...
	for (iCnt= 0; iCnt < 256; iCnt++) {
	    write_portA(iCnt);
	    printf ("\r  Current Counter Value= %3d", iCnt);
	    fflush(stdout);
	    usleep (100000);
	}
    }

    ssvhwa_close();

    return 0;
}
